/* $Id: ar_destroy.c,v 0.1 1997/10/14 18:23:03 rsmit06 Exp rsmit06 $
 *
 * This file is part of the array library (libar).
 * It implements the ar_destroy function.
 *
 * Copyright (C) 1997  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: ar_destroy.c,v $
 * Revision 0.1  1997/10/14 18:23:03  rsmit06
 * Initial code
 *
 */

#include <stdlib.h>
#include "arrayp.h"

/*
 * Destroys an array.
 */
void 
ar_destroy(array_p ar)
{
  if (ar == 0)
    ar_error("invalid parameter passed to ar_destroy");

  /* erase the structure */
  ar->cb_size = 0;
  ar->i_max = ar->i_free = 0;
  ar->num_grow = 0;

  /* free the data in the array */
  if (ar->data)
    free(ar->data);

  /* free the array structure */
  free(ar);
}


