/* $Id: ar_grow.c,v 0.1 1997/10/14 18:23:03 rsmit06 Exp rsmit06 $
 *
 * This file is part of the array library (libar).
 * It implements the ar_grow function.
 *
 * Copyright (C) 1997  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: ar_grow.c,v $
 * Revision 0.1  1997/10/14 18:23:03  rsmit06
 * Initial code
 *
 */

#include <stdlib.h>
#include <string.h>
#include "arrayp.h"

/*
 * Grows the array.
 */
void 
ar_grow(array_p ar)
{
  unsigned old_size;
  unsigned new_size;
  void *ptr;

  if (ar == 0)
    ar_error("parameter error in ar_grow");

  old_size = (ar->i_max + 1) * ar->cb_size;
  new_size = old_size + ar->num_grow * ar->cb_size;
  ptr = calloc(1, new_size);
  if (ptr == 0)
    ar_error("memory allocation failed in ar_grow");

  if (old_size > 0)
    memcpy(ptr, ar->data, old_size);
  if (ar->data)
    free(ar->data);
  ar->i_max += ar->num_grow;
  ar->data = ptr;
}
