/* $Id: ar_rm.c,v 1.1 1997/12/07 11:26:04 rsmit06 Exp $
 *
 * This file is part of the array library (libar).
 * It implements the ar_rm function.
 *
 * Copyright (C) 1997  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: ar_rm.c,v $
 * Revision 1.1  1997/12/07 11:26:04  rsmit06
 * Initial revision
 *
 *
 */

#include <string.h>
#include "arrayp.h"

/*
 * Removes the element at index `index' from the array. Reshuffles 
 * the array to fill the gap.
 */
void 
ar_rm(array_p ar, int index)
{
  char *dest, *src;

  /* trying to remove an invalid element */
  if (index >= ar->i_free || index < 1) {
    ar_error("trying to remove an unused element in ar_rm");
  }

  /* set the element at said index to 0's */
  dest = (char*)ar->data + (ar->cb_size * index);
  src = dest + ar->cb_size;
  memset(dest, 0, ar->cb_size);

  /* move the rest of the data one place back */
  memmove(dest, src, ar->i_free - index);
}
