/* $Id: ar_size.c,v 0.1 1997/10/14 18:23:03 rsmit06 Exp rsmit06 $
 *
 * This file is part of the array library (libar).
 * It implements the ar_size function.
 *
 * Copyright (C) 1997  R.F. Smith
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: ar_size.c,v $
 * Revision 0.1  1997/10/14 18:23:03  rsmit06
 * Initial code
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "arrayp.h"

/*
 * Returns the size of the array `ar', i.e. the number of items in use.
 */
int 
ar_size(array_p ar)
{
  /* check parameters */
  if (ar == 0)
    ar_error("invalid parameter passed to ar_size");

  /* return index of first free element = number of used elements! */
  return ar->i_free;
}
