/* artest.c 
 * Test for the array library (libar)
 * gcc -O2 -m486 -s -o artest artest.c -L. -lar_s
 */

#include <stdio.h>
#include "array.h"

int i[3] = {1,2,3};
int out[3] = {0,0,0};

void reset(void);
void compare(char *text);

int main(int argc, char *argv[])
{
  array_p a;

  /* create the array */
  a = ar_create(sizeof(int), 100, 10);
  printf("ar_size: %d\n", ar_size(a));

  /* normal write */
  ar_write(a, 0, 3, &i[0]);
  /* check */
  reset();
  ar_read(a, 0, 3, &out[0]);
  compare("normal write");
  printf("ar_size: %d\n", ar_size(a));


  /* write after used part */
  ar_write(a, 10, 3, &i[0]);
  /* check */
  reset();
  ar_read(a, 10, 3, &out[0]);
  compare("write after used part");
  printf("ar_size: %d\n", ar_size(a));

  /* write over array bounds */
  ar_write(a, 120, 3, &i[0]);
  /* check */
  reset();
  ar_read(a, 120, 3, &out[0]);
  compare("write over array bounds");
  printf("ar_size: %d\n", ar_size(a));

  ar_destroy(a);
  /* exit normally */
  return 0;
}

void reset(void)
{
  out[0] = out[1] = out[2] = 0;
}

void compare(char *text)
{
  if (i[0]==out[0] && i[1]==out[1] && i[2]==out[2]) {
    printf("check on %s: OK\n", text);
  } else {
    printf("check on %s: FAILED\n", text);
  }
}
